<template>
  <ObForm
    :form-data="formData"
    :form-model="formModel"
    :is-loading="isImportPending"
    :is-submit-disabled="!fileUuid"
    ok-text="Загрузить файл"
    data-qa="importFromExcelForm"
    @submit="onSubmit"
    class="form"
  >
    <p class="bottom-20">
      <template v-if="currentRole === 'client'">
        Вы можете заполнить таблицу лотов в Excel, используя
        специальный шаблон, а затем загрузить все данные в систему.
      </template>

      <template v-else>
        Вы можете заполнить таблицу лотов в Excel: выгрузить ее с помощью
        специального шаблона, внести ваши предложения, а затем загрузить все данные в систему.
      </template>
    </p>

    <h3 class="title">
      1. Скачайте шаблон
    </h3>

    <ObLoader
      v-if="isDownloadPending"
      class="download-loader"
      :size="30"
    />

    <a
      v-else
      @click="downloadTemplate"
      class="link-style bottom-20"
      href="#"
    >
      <template v-if="currentRole === 'client'">Шаблон в формате XLSX</template>
      <template v-else>Таблица лотов для {{ tenderNumber }} в формате XLSX</template>
    </a>

    <h3 class="title">
      2. Загрузите заполненный шаблон
    </h3>

    <p class="limitation-warning">
      Размер файла не должен превышать 1 Мб.
    </p>

    <ObAlert
      v-if="isErrorShown"
      text="Файл больше 1 Мб. Уменьшите его размер и прикрепите снова."
      theme="danger"
      icon="info"
    />

    <ObUploader
      ref="uploader"
      data-qa="uploader"
      @change="onUploaderChange"
    />
  </ObForm>
</template>

<script>
  import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
  import ObForm from 'common-components/src/obComponents/obForm'
  import ObUploader from 'common-components/src/obComponents/obUploader'
  import ObLoader from 'common-components/src/obComponents/obLoader'
  import ObAlert from 'common-components/src/obComponents/obAlert'
  import api from '@/api'
  import { required } from 'vuelidate/lib/validators'
  import { mapGetters } from 'vuex'

  export default {
    name: 'importExcel',
    components: {
      ObForm,
      ObUploader,
      ObLoader,
      ObAlert
    },
    mixins: [
      FormValidationMixin
    ],
    props: {
      tenderUuid: {
        type: String,
        required: true
      },
      requestUuid: {
        type: String,
        required: true
      },
      tenderNumber: {
        type: String,
        default: ''
      }
    },
    data () {
      return {
        fileUuid: null,
        isErrorShown: false,
        isDownloadPending: false,
        isImportPending: false
      }
    },
    computed: {
      ...mapGetters({
        currentRole: 'tenders/currentRole'
      }),
      formModel () {
        return {
          file: {
            required
          }
        }
      },
      role () {
        // Uppercase the first letter of current user role for API methods
        return this.currentRole.charAt(0).toUpperCase() + this.currentRole.slice(1)
      }
    },
    methods: {
      async downloadTemplate () {
        this.isDownloadPending = true

        let response

        if (this.currentRole === 'client') {
          response = await api.tendersExcels.downloadExcelTemplateForClient(this.tenderUuid)
        } else {
          response = await api.tendersExcels.downloadExcelTemplateForCarrier(this.tenderUuid, this.requestUuid)
        }

        const url = URL.createObjectURL(new Blob([response]))
        const link = document.createElement('a')

        link.href = url
        link.setAttribute('download', 'Шаблон.xlsx')

        document.body.appendChild(link)

        link.click()
        link.remove()

        this.isDownloadPending = false
      },
      async onUploaderChange (data) {
        this.isErrorShown = false

        data = data[0]

        if (!data) {
          this.fileUuid = null
          this.formData.file = undefined

          return false
        }

        if (data.file.size / 1024 / 1024 > 1) { // If more than 1Mb
          this.isErrorShown = true
          this.fileUuid = null
          this.formData.file = undefined

          this.$refs.uploader.files = []

          return false
        }

        this.fileUuid = data.uuid
        this.formData.file = data.file
      },
      async onSubmit () {
        // Prevent multiple submit
        if (this.isImportPending) {
          return
        }

        this.isImportPending = true

        try {
          const formData = new FormData()

          formData.append('file', this.formData.file)

          await api.tendersExcels[`uploadExcelTemplateFor${this.role}`](this.tenderUuid, this.requestUuid, formData)

          // Clear uploader
          this.$refs.uploader.removeFile(this.fileUuid)

          this.$emit('close')

          this.$notification({
            type: 'snackbars',
            message: 'Лоты успешно загружены'
          })
        } catch (e) {
          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка загрузки файла'
          })
        }

        this.isImportPending = false
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import '~common-components/src/static/css/mixins';

  $line-height: 20px;

  .form {
    line-height: 20px;
  }

  .title {
    @include font-mixin(16px, $line-height, bold, $color-text-base, 0.4px);

    margin-bottom: 6px;
  }

  .link-style {
    text-decoration: none;
  }

  .download-loader {
    margin-bottom: 20px;
    width: $line-height;
    height: $line-height;
    transition: none;
    transform: scale(0.5); // Equal to $line-height (50% of 40px)
  }

  .limitation-warning {
    margin-bottom: 10px;
  }

  .bottom-20 {
    margin-bottom: 20px;
  }
</style>
